=== debian/control ===
Source: ros-eloquent-realsense2-camera
Section: misc
Priority: optional
Maintainer: Doron Hirshberg <doron.hirshberg@intel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libopencv-dev, ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-builtin-interfaces, ros-eloquent-cv-bridge, ros-eloquent-diagnostic-updater, ros-eloquent-geometry-msgs, ros-eloquent-image-transport, ros-eloquent-nav-msgs, ros-eloquent-rclcpp, ros-eloquent-rclcpp-components, ros-eloquent-realsense-camera-msgs, ros-eloquent-sensor-msgs, ros-eloquent-std-msgs, ros-eloquent-tf2, ros-eloquent-tf2-ros, ros-eloquent-ros-workspace
Homepage: http://www.ros.org/wiki/RealSense
Standards-Version: 3.9.2

Package: ros-eloquent-realsense2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-eloquent-builtin-interfaces, ros-eloquent-cv-bridge, ros-eloquent-diagnostic-updater, ros-eloquent-geometry-msgs, ros-eloquent-image-transport, ros-eloquent-launch-ros, ros-eloquent-nav-msgs, ros-eloquent-rclcpp, ros-eloquent-rclcpp-components, ros-eloquent-realsense-camera-msgs, ros-eloquent-sensor-msgs, ros-eloquent-std-msgs, ros-eloquent-tf2, ros-eloquent-tf2-ros, ros-eloquent-ros-workspace
Description: RealSense Camera package allowing access to Intel SR300, D400 and L500 3D cameras
